package com.gic.auth.service;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.BusinessFrontResDTO;

import java.util.List;

/**
 * 业务前置资源
 * @ClassName: BusinessFrontResApiService 
 * @Description:  
 * @author guojuxing 
 * @date 2020/2/10 11:36 AM 
 */
public interface BusinessFrontResApiService {

    /**
     * 新增
     * @Title: save 
     * @Description:
     * @author guojuxing
     * @param dto 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Integer> 
     */
    ServiceResponse<Integer> save(BusinessFrontResDTO dto);
    /**
     * 编辑
     * @Title: edit 
     * @Description:
     * @author guojuxing
     * @param dto 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.String> 
     */
    ServiceResponse<String> edit(BusinessFrontResDTO dto);
    /**
     * 删除
     * @Title: delete 
     * @Description:
     * @author guojuxing
     * @param resourceId 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.String> 
     */
    ServiceResponse<String> delete(Integer resourceId);
    /**
     * @Title: listByParams 
     * @Description: 
     * @author guojuxing 
     * @param search 资源名称/资源详情
     * @param resourceType 1:页面 2：组件
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.String> 
     */
    ServiceResponse<List<BusinessFrontResDTO>> listByParams(String search, Integer resourceType);

    /**
     * 前置资源种类查询
     * @Title: listGroupResourceCode 
     * @Description:
     * @author guojuxing  
     * @return  com.gic.api.base.commons.ServiceResponse<java.util.List<com.gic.auth.dto.BusinessFrontResDTO>> 
     */
    ServiceResponse<List<BusinessFrontResDTO>> listGroupResourceCode();
}
