package com.gic.auth.dao.mapper;

import com.gic.auth.entity.TabSysOrderAppResource;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabSysOrderAppResourceMapper {
    /**
     * 根据主键删除
     *
     * @param orderAppResourceId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer orderAppResourceId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabSysOrderAppResource record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabSysOrderAppResource record);

    /**
     * 根据主键查询
     *
     * @param orderAppResourceId 主键
     * @return 实体对象
     */
    TabSysOrderAppResource selectByPrimaryKey(Integer orderAppResourceId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabSysOrderAppResource record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabSysOrderAppResource record);

    List<TabSysOrderAppResource> listByIds(@Param("ids") List<Integer> smsSignList, @Param("type") Integer type);
}