package com.gic.auth.dao.mapper;

import com.gic.auth.dto.UnionEnterpriseDTO;
import com.gic.auth.dto.UnionEnterpriseResourceDTO;
import com.gic.auth.entity.TabSysUnionEnterpriseResource;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabSysUnionEnterpriseResourceMapper {
    /**
     * 根据主键删除
     *
     * @param unionResourceId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer unionResourceId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabSysUnionEnterpriseResource record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabSysUnionEnterpriseResource record);

    /**
     * 根据主键查询
     *
     * @param unionResourceId 主键
     * @return 实体对象
     */
    TabSysUnionEnterpriseResource selectByPrimaryKey(Integer unionResourceId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabSysUnionEnterpriseResource record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabSysUnionEnterpriseResource record);

    List<TabSysUnionEnterpriseResource> getResource(@Param("unionId") Integer unionId, @Param("type") int type);

    int delResource(@Param("enterpriseId") Integer enterpriseId, @Param("unionId") Integer unionId);

    int updateAuthorizationStatus(@Param("authOrizationStatus") int authOrizationStatus,
                                  @Param("enterpriseId") Integer enterpriseId,
                                  @Param("resourceType") Integer resourceType,
                                  @Param("authOrizationMessage") String authOrizationMessage,
                                  @Param("key") String key);

    List<UnionEnterpriseResourceDTO> listResourceByEnterpriseIdAndType(@Param("enterpriseId") Integer enterpriseId,
                                                                       @Param("type") int type);

    List<TabSysUnionEnterpriseResource> listResourceByUnionId(@Param("unionId") Integer unionId);

    int delResourceByResourceId(Long resourceId);

    List<String> getKeyByResourceId(@Param("resourceId") Long resourceId);

    List<Integer> getUnionEnterpriseIdByResouce(@Param("resourceId") Long resourceId);
}