package com.gic.auth.service;

import com.gic.auth.dto.CollaboratorDTO;
import com.gic.auth.dto.CollaboratorListDTO;
import com.gic.auth.entity.TabSysCollaborator;
import com.gic.auth.qo.CollaboratorListQO;
import com.github.pagehelper.Page;

import java.util.List;

/**
 * 协作人接口
 * @ClassName: CollaboratorService 
 * @Description:  
 * @author guojuxing 
 * @date 2019/11/1 4:20 PM 
 */
public interface CollaboratorService {

    /**
     * 新增协作人
     * @Title: save 
     * @Description:
      * @author guojuxing
     * @param dto 
     * @return  java.lang.Integer 
      */
    Integer save(CollaboratorDTO dto);

    /**
     * 分页查询协作人列表
     * @Title: page 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  com.github.pagehelper.Page<com.gic.auth.dto.CollaboratorListDTO> 
      */
    Page<CollaboratorListDTO> page(CollaboratorListQO params);

    /**
     * 列表查询
     * @Title: listByEnterpriseId 
     * @Description: 
      * @author guojuxing 
     * @param collaboratorIdList 
     * @return  java.util.List<com.gic.auth.entity.TabSysCollaborator> 
      */
    List<TabSysCollaborator> listByCollaboratorIdList(List<Integer> collaboratorIdList);

    /**
     * 查询不在范围内的数据
     * @Title: listNotInCollaboratorIdList 
     * @Description: 
      * @author guojuxing 
     * @param collaboratorIdList 
     * @param search
     * @param enterpriseId
     * @return  java.util.List<com.gic.auth.entity.TabSysCollaborator> 
      */
    List<TabSysCollaborator> listNotInCollaboratorIdList(List<Integer> collaboratorIdList, String search,
            Integer enterpriseId);

    TabSysCollaborator getById(Integer id);

    void update(CollaboratorDTO dto);

    TabSysCollaborator getByPhoneAndAppId(Integer enterpriseId, String phone, String appId);

    void deleteByPhoneAndAppId(Integer enterpriseId, String phone, String appId);
}
