package com.gic.auth.service.impl;

import com.gic.auth.dao.mapper.TabSysBusinessFrontResMapper;
import com.gic.auth.dto.BusinessFrontResDTO;
import com.gic.auth.entity.TabSysBusinessFrontRes;
import com.gic.auth.service.BusinessFrontResService;
import com.gic.commons.util.EntityUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("businessFrontResService")
public class BusinessFrontResServiceImpl implements BusinessFrontResService{
    @Autowired
    private TabSysBusinessFrontResMapper tabSysBusinessFrontResMapper;

    @Override
    public Integer save(BusinessFrontResDTO dto) {
        dto.setStatus(1);
        dto.setCreateTime(new Date());
        dto.setUpdateTime(new Date());
        TabSysBusinessFrontRes record = EntityUtil.changeEntityNew(TabSysBusinessFrontRes.class, dto);
        tabSysBusinessFrontResMapper.insert(record);
        return record.getResourceId();
    }

    @Override
    public List<TabSysBusinessFrontRes> listByResourceCode(String resourceCode) {
        return tabSysBusinessFrontResMapper.listByResourceCode(resourceCode);
    }

    @Override
    public void edit(BusinessFrontResDTO dto) {
        dto.setUpdateTime(new Date());
        TabSysBusinessFrontRes record = EntityUtil.changeEntityNew(TabSysBusinessFrontRes.class, dto);
        tabSysBusinessFrontResMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public void delete(Integer resourceId) {
        TabSysBusinessFrontRes record = new TabSysBusinessFrontRes();
        record.setResourceId(resourceId);
        record.setStatus(0);
        record.setUpdateTime(new Date());
        tabSysBusinessFrontResMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public List<TabSysBusinessFrontRes> listByParam(String search, Integer resourceType) {
        return tabSysBusinessFrontResMapper.listByParam(search, resourceType);
    }

    @Override
    public List<TabSysBusinessFrontRes> listGroupResourceCode() {
        return tabSysBusinessFrontResMapper.listGroupResourceCode();
    }

    @Override
    public List<TabSysBusinessFrontRes> listByCode(List<String> codeList, Integer resourceType) {
        return tabSysBusinessFrontResMapper.listByCode(codeList, resourceType);
    }

    @Override
    public TabSysBusinessFrontRes getByResourceId(Integer resourceId) {
        return tabSysBusinessFrontResMapper.selectByPrimaryKey(resourceId);
    }
}
