package com.gic.auth.service.impl;

import com.gic.auth.dao.mapper.TabSysCollaboratorMapper;
import com.gic.auth.dto.CollaboratorDTO;
import com.gic.auth.dto.CollaboratorListDTO;
import com.gic.auth.entity.TabSysCollaborator;
import com.gic.auth.qo.CollaboratorListQO;
import com.gic.auth.service.CollaboratorService;
import com.gic.commons.util.EntityUtil;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("collaboratorService")
public class CollaboratorServiceImpl implements CollaboratorService {
    @Autowired
    private TabSysCollaboratorMapper tabSysCollaboratorMapper;

    @Override
    public Integer save(CollaboratorDTO dto) {
        dto.setCreateTime(new Date());
        dto.setUpdateTime(new Date());
        dto.setStatus(1);
        TabSysCollaborator record = EntityUtil.changeEntityNew(TabSysCollaborator.class, dto);
        tabSysCollaboratorMapper.insertSelective(record);
        return record.getCollaboratorId();
    }

    @Override
    public Page<CollaboratorListDTO> page(CollaboratorListQO params) {
        PageHelper.startPage(params.getCurrentPage(), params.getPageSize());
        return (Page<CollaboratorListDTO>) tabSysCollaboratorMapper.list(params);
    }

    @Override
    public List<TabSysCollaborator> listByCollaboratorIdList(List<Integer> collaboratorIdList) {
        return tabSysCollaboratorMapper.listByCollaboratorIdList(collaboratorIdList);
    }

    @Override
    public List<TabSysCollaborator> listNotInCollaboratorIdList(List<Integer> collaboratorIdList, String search,
            Integer enterpriseId) {
        return tabSysCollaboratorMapper.listNotInCollaboratorIdList(collaboratorIdList, search, enterpriseId);
    }

    @Override
    public TabSysCollaborator getById(Integer id) {
        return tabSysCollaboratorMapper.selectByPrimaryKey(id);
    }

    @Override
    public void update(CollaboratorDTO dto) {
        dto.setUpdateTime(new Date());
        TabSysCollaborator record = EntityUtil.changeEntityNew(TabSysCollaborator.class, dto);
        tabSysCollaboratorMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public TabSysCollaborator getByPhoneAndAppId(Integer enterpriseId, String phone, String appId) {
        TabSysCollaborator record = tabSysCollaboratorMapper.getByPhoneAndAppId(enterpriseId, phone, appId);
        return record;
    }

    @Override
    public void deleteByPhoneAndAppId(Integer enterpriseId, String phone, String appId) {
        tabSysCollaboratorMapper.deleteByPhoneAndAppId(enterpriseId, phone, appId);
    }
}
