package com.gic.auth.service.impl;

import com.gic.auth.dao.mapper.TabSysOperationUserMapper;
import com.gic.auth.dto.OperationUserDTO;
import com.gic.auth.entity.TabSysOperationUser;
import com.gic.auth.service.OperationUserService;
import com.gic.commons.util.EntityUtil;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service("operationUserService")
public class OperationUserServiceImpl implements OperationUserService{
    @Autowired
    private TabSysOperationUserMapper tabSysOperationUserMapper;
    @Override
    public OperationUserDTO getByPhone(String phone, Integer enterpriseId) {
        TabSysOperationUser record = tabSysOperationUserMapper.getByPhone(phone, enterpriseId);
        return EntityUtil.changeEntityNew(OperationUserDTO.class, record);
    }

    @Override
    public Integer save(OperationUserDTO dto) {
        dto.setCreateTime(new Date());
        dto.setUpdateTime(new Date());
        dto.setStatus(1);
        if (StringUtils.isBlank(dto.getPhoneAreaCode())) {
            dto.setPhoneAreaCode("86");
        }
        TabSysOperationUser record = EntityUtil.changeEntityNew(TabSysOperationUser.class, dto);
        tabSysOperationUserMapper.insert(record);
        return record.getOperationUserId();
    }
}
