package com.gic.auth.service.impl;

import com.gic.auth.dao.mapper.TabSysOrderAppResourceMapper;
import com.gic.auth.dto.OrderAppResourceDTO;
import com.gic.auth.entity.TabSysOrderAppResource;
import com.gic.auth.service.OrderAppResourceService;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GlobalInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019-09-25 15:53
 */
@Service
public class OrderAppResourceServiceImpl implements OrderAppResourceService {

    @Autowired
    private TabSysOrderAppResourceMapper tabSysOrderAppResourceMapper;

    @Override
    public Integer save(OrderAppResourceDTO orderAppResourceDTO) {
        TabSysOrderAppResource resource = EntityUtil.changeEntityByJSON(TabSysOrderAppResource.class, orderAppResourceDTO);
        resource.setCreateTime(new Date());
        resource.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
        tabSysOrderAppResourceMapper.insertSelective(resource);
        return resource.getOrderAppResourceId();
    }

    @Override
    public Integer update(OrderAppResourceDTO orderAppResourceDTO) {
        TabSysOrderAppResource orderAppResource = new TabSysOrderAppResource();
        orderAppResource.setOrderAppResourceId(orderAppResourceDTO.getOrderAppResourceId());
        orderAppResource.setContent(orderAppResourceDTO.getContent());
        return tabSysOrderAppResourceMapper.updateByPrimaryKeySelective(orderAppResource);
    }

    @Override
    public Integer del(Integer orderAppResourceId) {
        TabSysOrderAppResource orderAppResource = new TabSysOrderAppResource();
        orderAppResource.setOrderAppResourceId(orderAppResourceId);
        orderAppResource.setStatus(GlobalInfo.DATA_STATUS_DELETE);
        return tabSysOrderAppResourceMapper.updateByPrimaryKeySelective(orderAppResource);
    }

    @Override
    public TabSysOrderAppResource getById(Integer orderAppResourceId) {
        return tabSysOrderAppResourceMapper.selectByPrimaryKey(orderAppResourceId);
    }

    @Override
    public List<TabSysOrderAppResource> listByIds(List<Integer> smsSignList, Integer type) {
        return tabSysOrderAppResourceMapper.listByIds(smsSignList, type);
    }
}
